unit CritSect;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TCriticalSection = class(TComponent)
  private
    { Private declarations }
    FCS: TRTLCriticalSection;
    //FActive: Boolean;
    procedure SetActive(Value: Boolean);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Enter;
    procedure Leave;
    property Active: Boolean write SetActive default False;
  published
    { Published declarations }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('System', [TCriticalSection]);
end;

constructor TCriticalSection.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);
    InitializeCriticalSection(FCS);
end;

destructor TCriticalSection.Destroy;
begin
    DeleteCriticalSection(FCS);
    inherited Destroy;
end;

procedure TCriticalSection.Enter;
begin
    EnterCriticalSection(FCS);
end;

procedure TCriticalSection.Leave;
begin
    LeaveCriticalSection(FCS);
end;

procedure TCriticalSection.SetActive(Value: Boolean);
begin
    //FActive := Value;
    if not (csDesigning in ComponentState) then
    begin
        if Value then Enter
        else Leave;
    end;
end;

end.
